routes/web.php
        Route::get('/recipes/{recipe:slug|id}', 'DraftRecipesController@show');
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/recipes', 'DraftRecipesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/types', 'DraftsTypesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/posts', 'DraftProductsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Users')->prefix('users')->name('users.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/users', 'UsersController',
            [
                'except' => []
            ]);
    });

Route::namespace('Users')->prefix('users')->name('users.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/password', 'PasswordController',
            [
                'except' => []
            ]);
    });

Route::namespace('Users')->prefix('users')->name('users.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/profile', 'ProfilesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Home')->prefix('home')->name('home.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/home', 'HomeController',
            [
                'except' => []
            ]);
    });

//Route::namespace('Home')->prefix('home')->name('home.')
//    ->middleware('can:administration')->group(function (){
//    Route::resource('/contacts', 'ContactUsController',
//        [
//            'except' => []
//        ]);
//});

Route::namespace('Images')->prefix('images')->name('images.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/images', 'ImagesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Ratings')->prefix('ratings')->name('ratings.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/ratings', 'RatingsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Ratings')->prefix('ratings')->name('ratings.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/values', 'RatingValuesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Comments')->prefix('comments')->name('comments.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/comments', 'CommentsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Comments')->prefix('comments')->name('comments.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/values', 'RatingCommentsValuesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::get('/books/create', 'BooksController@create');
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::get('/books/{books:slug}', 'BooksController@show');
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/books', 'BooksController',
            [
                'except' => []
            ]);
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/buy', 'BuyFromController',
            [
                'except' => []
            ]);
    });

Route::namespace('Subscribers')->prefix('subscribers')->name('subscribers.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/subscribers', 'SubscribersController',
            [
                'except' => []
            ]);
    });


/*
 * Publish routes
 */


Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/publish', 'PublishController',
            [
                'except' => ['index', 'show', 'edit', 'destroy', 'create', 'store']
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/preparing', 'PreparingController',
            [
                'except' => ['index', 'show', 'edit', 'destroy', 'create', 'store']
            ]);
    });


Route::group(['middleware' => ['can:administration', 'archive']], function () {

        Route::get('/analyst/archive', 'Administrator\AnalystController@archive')
            ->name('analyst.archive');
        Route::get('/analyst/archive/sort/{value}/{where}', 'Administrator\AnalystController@archiveSort')
            ->name('analyst.archive.sort');
        Route::get('/analyst/archive/delete', 'Administrator\AnalystController@archiveDelete')
            ->name('analyst.archive.delete');

        Route::patch('/analyst/archive/chosen', 'Administrator\AnalystController@archiveChosen')
            ->name('analyst.archive.delete-chosen');


        Route::get('/analyst', 'Administrator\AnalystController@index')
            ->name('analyst.index');
        Route::get('/analyst/sort/{value}/{where}', 'Administrator\AnalystController@sort')
            ->name('analyst.sort');
        Route::get('/analyst/look/{value}/{look}', 'Administrator\AnalystController@look')
            ->name('analyst.look');
        Route::get('/analyst/by-date/{key}', 'Administrator\AnalystController@byDate')
            ->name('analyst.by-date');

        Route::get('/analyst/custom-analyst', 'Administrator\AnalystController@custom')
            ->name('analyst.custom-analyst');
        Route::get('/analyst/custom-analyst/sort/{analystCustom}/{value}/{where}', 'Administrator\AnalystController@customSort')
            ->name('analyst.custom-analyst.sort');
        Route::post('/analyst/custom-analyst', 'Administrator\AnalystController@customStore')
            ->name('analyst.custom-analyst.store');
        Route::get('/analyst/custom-analyst/{analystCustom}', 'Administrator\AnalystController@customShow')
            ->name('analyst.custom-analyst.show');
        Route::delete('/analyst/custom-analyst/{analystCustom}', 'Administrator\AnalystController@customDelete')
            ->name('analyst.custom-analyst.delete');

        Route::get('/analyst/in-progress', 'Administrator\AnalystController@inProgress')
            ->name('analyst.in-progress');

        //counters

        Route::get('/counter/index/{key}', 'Administrator\CountsController@index')
            ->name('counter.index');
        Route::get('/counter/by/{countType}/{key}', 'Administrator\CountsController@by')
            ->name('counter.by');
        Route::get('/counter/custom', 'Administrator\CountsController@custom')
            ->name('counter.custom');
        Route::post('/counter/custom', 'Administrator\CountsController@customStore')
            ->name('counter.custom.store');
        Route::get('/counter/custom/{countableCustom}', 'Administrator\CountsController@customShow')
        ->name('counter.custom.show');
        Route::delete('/counter/custom/{countableCustom}', 'Administrator\CountsController@customDelete')
            ->name('counter.custom.delete');




        Route::get('/counter/admin/{pass}', 'Administrator\CountsController@admin')
            ->name('counter.admin');
        Route::get('/counter/change/{pass}', 'Administrator\CountsController@adminChangeDraftToRecipes')
            ->name('counter.change');



    /*
     * partners
     */

    Route::get('/partners', 'Partners\PartnersController@index')
        ->name('partners');
    Route::post('/partners', 'Partners\PartnersController@store')
        ->name('partners-post');
    Route::get('/partners/{partner}', 'Partners\PartnersController@show')
        ->name('partners-show');
    Route::delete('/partners/{partner}', 'Partners\PartnersController@destroy')
        ->name('partners-destroy');
    Route::patch('/partners/{partner}', 'Partners\PartnersController@update')
        ->name('partners-update');

    /*
     * contact us controller
     */

    Route::get('/contacts/{messageType}', 'Home\ContactUsController@index')
        ->name('contacts');

    Route::get('/contacts/delete/{message}', 'Home\ContactUsController@delete')
        ->name('delete-message');

    /*
     * blog
     */
    Route::get('/posts', 'Home\PostsController@index')
        ->name('blog');
    Route::post('/posts', 'Home\PostsController@store')
        ->name('blog-store');
    Route::get('/posts/{post}', 'Home\PostsController@show')
        ->name('blog-show');
    Route::put('/posts/{post}', 'Home\PostsController@update')
        ->name('blog-update');
    Route::delete('/posts/{post}', 'Home\PostsController@destroy')
        ->name('blog-delete');

    /*
     * youtube
     */
    Route::get('/tube', 'Home\PostsController@tube')
        ->name('youtube');
    Route::post('/tube', 'Home\PostsController@tubeStore')
        ->name('tube-store');
    Route::get('/tube/{tube}', 'Home\PostsController@tubeShow')
        ->name('tube-show');
    Route::put('/tube/{tube}', 'Home\PostsController@tubeUpdate')
        ->name('tube-update');

app/Models/Book.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Book extends Model
{
    protected $guarded = [];

    public function buyFrom()
    {
        return $this->belongsToMany('App\Models\BuyFrom', 'buying_books', 'book_id', 'from_where_id');
    }
}

app/Http/Controllers/Books/BooksController.php
<?php

namespace App\Http\Controllers\Books;

use App\Http\Controllers\Controller;
use App\Models\Book;
use App\Repositories\BooksRepositoryInterface;
use App\Repositories\TrafficRepositoryInterface;
use Illuminate\Http\Request;

class BooksController extends Controller
{

    /**
     * @var TrafficRepositoryInterface
     */
    private $trafficRepository;
    /**
     * @var BooksRepositoryInterface
     */
    private $booksRepository;

    public function __construct(TrafficRepositoryInterface $trafficRepository,
                                BooksRepositoryInterface $booksRepository)
    {
        $this->trafficRepository = $trafficRepository;
        $this->booksRepository = $booksRepository;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $action = 'index';
        $this->trafficRepository->getRemoteAddress($action);

        $books = $this->booksRepository->getAllBooks();

        return view('books.books.index')->with('books', $books);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $action = 'create';
        $this->trafficRepository->getRemoteAddress($action);

        $books = $this->booksRepository->getAllBooks();

        return view('books.books.create')->with('books', $books);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $action = 'store';
        $this->trafficRepository->getRemoteAddress($action);

        $store = $this->booksRepository->addNewBook($request);
        if (!empty($store)) {
            $request->session()->flash('success', 'The the book is stored successfully!');
        } else {
            $request->session()->flash('danger', 'There was an error storing the book');
        }
        return redirect()->route('books.books.create');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Book  $books
     * @return \Illuminate\Http\Response
     */
    public function show(Book $books)
    {
        $action = 'show';
        $this->trafficRepository->getRemoteAddress($action);

        $publishers = $this->booksRepository->getAllPublishers();

        return view('books.books.show')->with(
            [
                'book' => $books,
                'publishers' => $publishers,
            ]
        );
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function edit(Book $book)
    {
        $action = 'edit';
        $this->trafficRepository->getRemoteAddress($action);

        $publishers = $this->booksRepository->getAllPublishers();

        return view('books.books.edit')->with(
            [
                'book' => $book,
                'publishers' => $publishers,
            ]
        );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Book $book)
    {
        $action = 'update';
        $this->trafficRepository->getRemoteAddress($action);

        $this->booksRepository->editExistingBook($request, $book);

        return $this->show($book);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function destroy(Book $book)
    {
        $action = 'destroy';
        $this->trafficRepository->getRemoteAddress($action);

        $this->booksRepository->deleteBook($book);

        return $this->create();
    }
}

app/Http/Controllers/Books/BuyFromController.php
<?php

namespace App\Http\Controllers\Books;

use App\Http\Controllers\Controller;
use App\Models\BuyFrom;
use App\Repositories\BooksRepositoryInterface;
use App\Repositories\TrafficRepositoryInterface;
use Illuminate\Http\Request;

class BuyFromController extends Controller
{


    /**
     * @var TrafficRepositoryInterface
     */
    private $trafficRepository;
    /**
     * @var BooksRepositoryInterface
     */
    private $booksRepository;

    public function __construct(TrafficRepositoryInterface $trafficRepository,
                                BooksRepositoryInterface $booksRepository)
    {
        $this->trafficRepository = $trafficRepository;
        $this->booksRepository = $booksRepository;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $action = 'index';
        $this->trafficRepository->getRemoteAddress($action);

        dd(1);

        return $this->index();
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $action = 'create';
        $this->trafficRepository->getRemoteAddress($action);

        $publishers = $this->booksRepository->getAllPublishers();

        return view('books.buy.create')->with('publishers', $publishers);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $action = 'store';
        $this->trafficRepository->getRemoteAddress($action);
        $store = $this->booksRepository->addPublisher($request);
        if (!empty($store)) {
            $request->session()->flash('success', 'The the publisher is stored successfully!');
        } else {
            $request->session()->flash('danger', 'There was an error storing the publisher');
        }
        return redirect()->route('books.buy.create');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\BuyFrom  $buy
     * @return \Illuminate\Http\Response
     */
    public function show(BuyFrom $buy)
    {
        $action = 'show';
        $this->trafficRepository->getRemoteAddress($action);

        return view('books.buy.show')->with('publisher', $buy);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\BuyFrom  $buyFrom
     * @return \Illuminate\Http\Response
     */
    public function edit(BuyFrom $buyFrom)
    {
        $action = 'edit';
        $this->trafficRepository->getRemoteAddress($action);

        return $this->index();
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\BuyFrom  $buyFrom
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, BuyFrom $buyFrom)
    {
        $action = 'update';
        $this->trafficRepository->getRemoteAddress($action);

        return $this->index();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\BuyFrom  $buy
     * @return \Illuminate\Http\Response
     */
    public function destroy(BuyFrom $buy)
    {
        $action = 'destroy';
        $this->trafficRepository->getRemoteAddress($action);

        $this->booksRepository->deletePublisher($buy);

        return $this->create();
    }
}

resources/views/books/books/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <div class="container">
                    <div class="row">
                        <div class="col-md-8">
                            <div class="card my-3 mx-auto">
                                <div class="card-header">
                                    <h4 class="text-center">
                                        Книги
                                    </h4>
                                </div>
                                <div class="card-body">
                                    <div class="well">
                                        <table class="table table-borderless">
                                            <thead>
                                            <tr>
                                                <th>#</th>
                                                <th>Заглавие</th>
                                                <th>Цена в лв.</th>
                                                <th>Действия</th>
                                            </tr>
                                            </thead>
                                            <tbody>
                                            @foreach($books as $book)
                                                <tr>
                                                    <td>{{$book->id}}</td>
                                                    <td>{{$book->title}}</td>
                                                    <td>{{$book->price}} лв.</td>
                                                    <td>
                                                        <a href="{{ route('books.books.edit', $book->id) }}"
                                                           class="float-left mx-1">
                                                            <button type="button" class="btn btn-outline-dark">
                                                                Редактирай
                                                            </button>
                                                        </a>
                                                        <a href="{{ route('books.books.show', $book->slug) }}"
                                                           class="float-left mx-1">
                                                            <button type="button" class="btn btn-outline-success">
                                                                Виж
                                                            </button>
                                                        </a>
                                                        <form action="{{ route('books.books.destroy', $book->id) }}"
                                                              method="POST" class="float-left mx-1">
                                                            @csrf
                                                            @method('DELETE')
                                                            <button type="submit" class="btn btn-outline-danger"
                                                                    onclick="alert('Сигурен ли сте, че искате да изтриете тази книга?')">
                                                                Изтрий
                                                            </button>
                                                        </form>
                                                    </td>
                                                </tr>
                                            @endforeach
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-4 my-3">
                            <div class="well">
                                <h4 class="text-center">
                                    <label>
                                        Добави нова книга
                                    </label>
                                </h4>
                                <form action="{{ route('books.books.store') }}" method="POST"
                                      enctype="multipart/form-data">
                                    @csrf
                                    <div class="card">
                                        <div class="card-header">
                                            <label>Добави нова книга:</label>
                                        </div>
                                        <div class="card-body">
                                            <label for="title">
                                                Заглавие:
                                            </label>
                                            <input id="title"
                                                   type="text"
                                                   class="form-control @error('title') is-invalid @enderror"
                                                   name="title"
                                                   value="{{ old('title') }}"
                                                   required autocomplete="title" autofocus>
                                            @error('title')
                                            <br>
                                            <span class="invalid-feedback" role="alert">
                                                        <strong>{{ $message }}</strong>
                                                    </span>
                                            @enderror
                                        </div>
                                        <div class="card-body">
                                            <label for="slug">
                                                Заглавие на латиница:
                                            </label>
                                            <input id="slug"
                                                   type="text"
                                                   class="form-control @error('slug') is-invalid @enderror"
                                                   name="slug"
                                                   value="{{ old('slug') }}"
                                                   required autocomplete="slug" autofocus>
                                            @error('slug')
                                            <br>
                                            <span class="invalid-feedback" role="alert">
                                                        <strong>{{ $message }}</strong>
                                                    </span>
                                            @enderror
                                        </div>
                                        <div class="card-body">
                                            <label for="description">
                                                Кратко описание:
                                            </label>
                                            <textarea id="description"
                                                      type="text"
                                                      class="form-control @error('description') is-invalid @enderror"
                                                      name="description"
                                                      required autocomplete="description"
                                                      autofocus>{{ old('description') }}</textarea>
                                            @error('description')
                                            <br>
                                            <span class="invalid-feedback" role="alert">
                                                        <strong>{{ $message }}</strong>
                                                    </span>
                                            @enderror
                                        </div>
                                        <div class="card-body">
                                            <label for="price">
                                                Цена:
                                            </label>
                                            <input id="price"
                                                   type="text"
                                                   class="form-control @error('price') is-invalid @enderror"
                                                   name="price"
                                                   value="{{ old('price') }}"
                                                   required autocomplete="price" autofocus>
                                            @error('price')
                                            <br>
                                            <span class="invalid-feedback" role="alert">
                                                        <strong>{{ $message }}</strong>
                                                    </span>
                                            @enderror
                                        </div>
                                        <div class="card-body">
                                            <label for="image">Снимка</label>
                                            <div class="col-md-6">
                                                <input type="file" id="image" name="image">
                                                @if($errors->has('image'))
                                                    <strong>{{ $errors->first('image') }}</strong>
                                                @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="d-flex justify-content-center m-2">
                                        <button type="submit" class="btn btn-dark">
                                            Добави
                                        </button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/books/books/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row my-3 justify-content-center">
            <label class="text-center">
                Blog:
            </label>
        </div>
    </div>
    <div class="container">
        <div class="row mx-auto my-2 justify-content-center">
            @foreach($books as $book)
                <div class="mx-5">
                    <div class="text-center">
                        <label class="font-weight-bold" style="font-size: 18px">
                            {{ $book->title }}
                        </label>
                        <hr>
                    </div>
                    <div class="row m-5">
                        <div class="col-sm-5">
                            <img src="{{ $book->image }}" class="w-75">
                        </div>
                        <div class="col-sm-7">
                            <p>
                                {{$book->description}}
                            </p>
                            <p>
                                Цена: {{$book->price}}
                            </p>
                            <ul>
                                Издателство:
                                @foreach($book->buyFrom as $publisher)
                                    <li>
                                        <a href="{{$publisher->url}}">
                                            <span class="font-weight-bold">
                                                {{$publisher->from_where}}
                                            </span>
                                        </a>
                                    </li>
                                @endforeach
                            </ul>

                            <div class="text-center">
                                <a href="{{route('books.books.show', $book->slug)}}">
                                    <button type="button" class="btn btn-dark">Покажи</button>
                                </a>
                            </div>
                        </div>
                    </div>
                </div>
            @endforeach
        </div>
    </div>
@endsection